define(["require","exports","module","lib/create-thumbnail-image","debug","views/preview-gallery","lib/prepare-preview-blob","lib/resize-image-and-save","lib/string-utils","lib/bind-all","CustomDialog"],function(t,e,i){function s(t){h(this),this.app=t,this.settings=t.settings,this.dialog=t.dialog||u,this.resizeImageAndSave=l,this.bindEvents(),this.configure(),n("initialized")}var o=t("lib/create-thumbnail-image"),n=t("debug")("controller:preview-gallery"),a=t("views/preview-gallery"),r=t("lib/prepare-preview-blob"),l=t("lib/resize-image-and-save"),c=t("lib/string-utils"),h=t("lib/bind-all"),u=t("CustomDialog");i.exports=function(t){return new s(t)},i.exports.PreviewGalleryController=s,s.prototype.bindEvents=function(){this.app.on("storage:itemdeleted",this.onItemDeleted),this.app.on("storage:changed",this.onStorageChanged),this.app.on("preview",this.openPreview),this.app.on("newmedia",this.onNewMedia),this.app.on("hidden",this.onHidden),n("events bound")},s.prototype.configure=function(){this.currentItemIndex=0,this.items=[],this.thumbnailItem=null;var t=window.devicePixelRatio;this.thumbnailSize={width:this.settings.previewGallery.get("thumbnailWidth")*t,height:this.settings.previewGallery.get("thumbnailHeight")*t}},s.prototype.openPreview=function(){if(!this.app.activity.pick&&!this.view){var t=window.CONFIG_MAX_IMAGE_PIXEL_SIZE;this.view=new a,this.view.maxPreviewSize=t,this.view.render().appendTo(this.app.el),this.view.on("click:gallery",this.onGalleryButtonClick),this.view.on("click:share",this.shareCurrentItem),this.view.on("click:delete",this.deleteCurrentItem),this.view.on("click:back",this.closePreview),this.view.on("swipe",this.handleSwipe),this.view.on("click:options",this.onOptionsClick),this.view.on("loadingvideo",this.app.firer("busy")),this.view.on("playingvideo",this.app.firer("ready"));var e=this.app.inSecureMode;this.view.set("secure-mode",e),this.view.open(),this.previewItem(),this.app.emit("previewgallery:opened")}},s.prototype.closePreview=function(){this.thumbnailItem!==this.items[0]&&this.updateThumbnail(),this.view&&(this.currentItemIndex=0,this.view.close(),this.view.destroy(),this.view=null),this.app.emit("previewgallery:closed")},s.prototype.onGalleryButtonClick=function(){if(!this.app.inSecureMode){var t=window.MozActivity;this.mozActivity=new t({name:"browse",data:{type:"photos"}})}},s.prototype.onOptionsClick=function(){this.app.inSecureMode||this.view.showOptionsMenu()},s.prototype.shareCurrentItem=function(){if(!this.app.inSecureMode){var t=this.currentItemIndex,e=this.items[t],i=e.isVideo?"video/*":"image/*",s=c.lastPathComponent(e.filepath),o=function(t){var o=new window.MozActivity({name:"share",data:{type:i,number:1,blobs:[t],filenames:[s],filepaths:[e.filepath]}});o.onerror=function(){console.warn("Share activity error:",o.error.name)}};if(e.isVideo)return o(e.blob),void 0;var n=this;this.stopItemDeletedEvent=!0,this.resizeImageAndSave({blob:e.blob,size:this.settings.activity.get("maxSharePixelSize")},function(t){n.stopItemDeletedEvent=!1,o(t)})}},s.prototype.deleteCurrentItem=function(){function t(){a.hide()}function e(){a.hide(),r.updatePreviewGallery(s),o.isVideo?r.app.emit("previewgallery:deletevideo",n):r.app.emit("previewgallery:deletepicture",n)}if(!this.app.inSecureMode){var i,s=this.currentItemIndex,o=this.items[s],n=o.filepath,a=this.dialog,r=this;i=o.isVideo?"delete-video?":"delete-photo?",a.show("",i,{title:"cancel",callback:t},{title:"delete",callback:e,recommend:!1})}},s.prototype.updatePreviewGallery=function(t){if(this.items.splice(t,1),0===this.items.length)this.closePreview();else{t==this.items.length&&(this.currentItemIndex=this.items.length-1);var e=this.view?!0:!1;e&&this.previewItem()}},s.prototype.handleSwipe=function(t){"left"===t?this.next():"right"===t&&this.previous()},s.prototype.next=function(){this.currentItemIndex<this.items.length-1&&(this.currentItemIndex+=1,this.previewItem())},s.prototype.previous=function(){this.currentItemIndex>0&&(this.currentItemIndex-=1,this.previewItem())},s.prototype.onNewMedia=function(t){function e(t){i.items.unshift(t),i.updateThumbnail()}if(!this.app.activity.pick){var i=this;t.isVideo?e(t):r(t.blob,function(i){i.blob=t.blob,i.filepath=t.filepath,e(i)})}},s.prototype.previewItem=function(){var t=this.currentItemIndex,e=this.items[t];this.view.updateCountText(t+1,this.items.length),e.isVideo?this.view.showVideo(e):this.view.showImage(e)},s.prototype.onStorageChanged=function(t){"unavailable"===t&&(this.configure(),this.updateThumbnail())},s.prototype.onItemDeleted=function(t){if(!this.stopItemDeletedEvent){for(var e=-1,i=t.path,s=0;s<this.items.length;s++)if(this.items[s].filepath===i){e=s;break}s!==this.items.length&&this.updatePreviewGallery(e)}},s.prototype.onHidden=function(){this.app.inSecureMode&&(this.configure(),this.updateThumbnail()),this.closePreview()},s.prototype.updateThumbnail=function(){function t(t){i.app.emit("newthumbnail",t)}var e,i=this,s=this.thumbnailItem=this.items[0]||null;if(null===s)return this.app.emit("newthumbnail",null),void 0;if(s.isVideo)e=s.poster.blob;else{if(s.preview){var n=s.width/s.height,a=s.preview.width/s.preview.height;Math.abs(n-a)<.01&&(e=s.blob.slice(s.preview.start,s.preview.end,"image/jpeg"))}e||(e=s.blob)}o(e,s,this.thumbnailSize,t)}});